local gr = love.graphics
local pi,sin,cos,atan,sqrt,abs = math.pi,math.sin,math.cos,math.atan,math.sqrt,math.abs
function love.load()
	love.window.setTitle( 'Try keys r/e and a/s.' )
	cir = {
		{400,100,15},{550,300,10},{400,450, 5},{140,300,12},
		{170,170,12},{450,250, 6},{420,375, 9},{300,400, 6}}
	arc = {
		loc = {400,300},
		l = 250,
		a1 = 0,
		a2 = pi/8
		}
	arc.a = ( arc.a1 + arc.a2 ) / 2		-- arc vector
	arc.d = abs( arc.a2 - arc.a1 ) / 2	-- 1/2 arc width
	end

function love.update( dt )
	arc.a = arc.a + dt
	if arc.a > 2*pi then arc.a = arc.a - 2*pi end
	end

function love.draw()
	gr.setColor( 0.4, 0.2, 0.2 )
	gr.arc( 'fill', arc.loc[1], arc.loc[2], arc.l, arc.a-arc.d, arc.a+arc.d )
	for i = 1, #cir do
		if contactArcCircle( cir[i], arc ) then
			gr.setColor(1,0,0)
			else gr.setColor(.5,1,.5)
			end
		gr.circle( 'fill', cir[i][1], cir[i][2], cir[i][3] )
		end
	gr.setColor( 0, 1, 1 )
	gr.arc( 'line', arc.loc[1], arc.loc[2], arc.l, arc.a-arc.d, arc.a+arc.d )
	end

function love.keypressed( key )
	if key == 'escape' then love.event.push( 'quit' )	end
	if key == 's' then arc.d = arc.d<pi/2 and arc.d+.1  or pi/2 end
	if key == 'a' then arc.d = arc.d >.2 and arc.d-.1 or .1 end
	if key == 'r' then arc.l = arc.l+4 end
	if key == 'e' then arc.l = arc.l-4 end
	end

contactArcCircle = function( c, a )
	local dis, dang, pang
	dis = dist( {c[1],c[2]}, a.loc )
	dang = atan( c[3]/dis )						-- angle: circle center to circle edge
	pang = angle( {c[1],c[2]}, a.loc ) + pi-- angle: circle center to arc center
	return (pang+dang)>a.a-a.d and (pang-dang)<a.a+a.d and dis<=(a.l+c[3])
	end

angle = function( p1, p2 )	-- angle between two points
	local dx,dy = p2[1]-p1[1], p2[2]-p1[2]
	return math.atan2( dy, dx )
	end

dist = function( p1, p2 )	-- get distance between two points (note sqrt)
	return sqrt( ( p2[1] - p1[1] )^2 + ( p2[2] - p1[2] )^2 )
	end